﻿//////////////////////////////////////////////
// ComplexEffect.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class CompositorNode ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Dll/DllDefines.h"

#include "ComplexEffectType.h"

// nkMemory
#include <NilkinsMemory/Containers/String.h>
#include <NilkinsMemory/Containers/StringView.h>

/// Class ------------------------------------

namespace nkAstraeus
{
	class DLL_ASTRAEUS_EXPORT ComplexEffect
	{
		protected :

			// Attributes
			// Name for identification
			nkMemory::String _name ;

			// CompositorNode we reference
			nkGraphics::CompositorNode* _compositorNode ;


		protected :

			// Functions
			// Name compilation
			nkMemory::String _getShaderName () const ;

		public :

			// Constructor, destructor
			ComplexEffect (nkMemory::StringView name) ;
			virtual ~ComplexEffect () ;

			// Getters
			nkMemory::StringView getName () const ;
			nkGraphics::CompositorNode* getCompositorNode () const ;
			virtual COMPLEX_EFFECT_TYPE getType () const = 0 ;

			// Setters
			void setName (const nkMemory::StringView& value) ;
			void setCompositorNode (nkGraphics::CompositorNode* value) ;

			// Load
			virtual bool load () = 0 ;
			virtual void unload () = 0 ;
	} ;
}