﻿//////////////////////////////////////////////
// AtmosphereLutProgramTracker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Program ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Utils/ProgramTracker.h"

#include "AtmosphereEffectInfo.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

/// Internals --------------------------------

namespace nkAstraeus
{
	struct AtmosphereLutProgramIdGenerator
	{
		static unsigned long long generate (const AtmosphereEffectInfo& info) ;
	} ;

	struct AtmosphereLutProgramNameGenerator
	{
		constexpr static const char* name = "NILKINS_ATMOSPHERE_LUT_PROGRAM_" ;
	} ;
}

/// Class ------------------------------------

namespace nkAstraeus
{
	class AtmosphereLutProgramTracker final : public ProgramTracker<AtmosphereEffectInfo, AtmosphereLutProgramIdGenerator, AtmosphereLutProgramNameGenerator>, public nkCommon::SingletonClass<AtmosphereLutProgramTracker>
	{
		friend class SingletonClass<AtmosphereLutProgramTracker> ;

		private :

			// Functions
			// Constructor, destructor
			AtmosphereLutProgramTracker () ;
			~AtmosphereLutProgramTracker () ;
	} ;
}