﻿//////////////////////////////////////////////
// EnvironmentRenderer.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Shader ;
	class Texture ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Dll/DllDefines.h"

// nkGraphics
#include <NilkinsGraphics/Utils/DxDefinesWrapper.h>

/// Class ------------------------------------

namespace nkAstraeus
{
	class DLL_ASTRAEUS_EXPORT EnvironmentRenderer final
	{
		private :

			// Constructor, destructor
			EnvironmentRenderer () = delete ;
			~EnvironmentRenderer () = delete ;

		public :

			// Rendering
			static void renderCubemap (nkGraphics::Texture* output, nkGraphics::Shader* shader, unsigned int targetDimensions, nkGraphics::FORMAT targetFormat) ;
			static void cubemapToSphericalMap (nkGraphics::Texture* output, nkGraphics::Texture* input, unsigned int targetWidth, unsigned int targetHeight) ;
	} ;
}