﻿//////////////////////////////////////////////
// ResourceSettingsChecker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	struct MapRequestDescriptor ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../Buffers/Enums/BufferUsage.h"

#include "../Utils/DxDefinesWrapper.h"

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

/// Class ------------------------------------

namespace nkGraphics
{
	class ResourceSettingsChecker
	{
		private :

			// Constructor, destructor
			ResourceSettingsChecker () ;
			~ResourceSettingsChecker () ;

		public :

			// Check whether the resource settings will allow its creation or not
			static bool checkResourceCreationSettings (BUFFER_USAGE usageFlag, unsigned int bindFlags, unsigned int cpuFlags, unsigned int miscFlags, void* cpuData, const nkMemory::StringView& resourceName) ;

			// Check whether the settings allow a map of the resource or not
			static bool checkResourceMapCapacity (const MapRequestDescriptor& mapRequest, BUFFER_USAGE usageFlag, unsigned int cpuFlags, bool texture, const nkMemory::StringView& resourceName) ;
			// Check whether the settings require a copy of the resource before mapping or not
			static bool resourceNeedsStagingMap (const MapRequestDescriptor& mapRequest, BUFFER_USAGE usageFlag, unsigned int cpuFlags, bool texture, const nkMemory::StringView& resourceName) ;
	} ;
}