﻿//////////////////////////////////////////////
// LambdaSchedulerTask.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkTasks
#include "../Dll/DllDefines.h"

#include "../Tasks/LambdaTask.h"

#include "SchedulerTask.h"

/// Class ------------------------------------

namespace nkTasks
{
	class DLL_TASKS_EXPORT LambdaSchedulerTask : public SchedulerTask
	{
		private :
		
			// Attributes
			// Used callbacks
			std::function<void()> _asyncWorkFunction ;
			std::function<void()> _syncFunction ;
			
		public :
		
			// Constructor, destructor
			LambdaSchedulerTask () ;
			LambdaSchedulerTask (std::function<void ()> asyncWorkFunction, std::function<void ()> syncFunction) ;
			~LambdaSchedulerTask () ;

			// Setters
			void setAsyncWorkFunction (std::function<void()> value) ;
			void setSyncFunction (std::function<void()> value) ;

			// Implement base methods
			virtual void onAsyncWork () override ;
			virtual void onSync () override ;

			
	} ;
}