﻿//////////////////////////////////////////////
// CheckBox.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "Component.h"

#include "../Dll/DllDefines.h"

// Standards
#include <functional>

/// Class ------------------------------------
	
namespace nkWinUi
{
	class DLL_WINUI_EXPORT CheckBox : public Component
	{
		protected :
		
			// Attributs
			// Callback
			std::function<void (CheckBox*)> _checkCallback ;
		
		public :
		
			// Constructeur, destructeur
			CheckBox (MainSystem* parentSystem) ;
			~CheckBox () ;

			// Getters
			virtual bool isChecked () const = 0 ;
			std::function<void (CheckBox*)> getCheckCallback () const ;

			// Setters
			virtual void setChecked (bool val) = 0 ;
			void setCheckCallback (std::function<void (CheckBox*)> value) ;
	} ;
}