﻿//////////////////////////////////////////////
// ImageManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	class Image ;
	class MainSystem ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"
	
// nkCommon
#include <nilkinsCommon/Patterns/MaybeSingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <string>
#include <unordered_map>

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT ImageManager final : public nkCommon::MaybeSingletonClass<ImageManager>
	{
		friend class nkCommon::MaybeSingletonClass<ImageManager> ;
		friend class MainSystem ;

		private :

			// Attributes
			// Memory
			std::unordered_map<std::string, Image*> _memory ;

			MainSystem* _parentSystem ;

		private :

			// Functions
			// Constructor, destructor
			ImageManager () ;
			ImageManager (MainSystem* parentSystem) ;
			~ImageManager () ;
		
		public :
		
			// Memory management
			Image* createOrRetrieve (const nkMemory::StringView& name) ;
			Image* get (const nkMemory::StringView& name) const ;
			Image* getByIndex (unsigned int index) const ;
			void rename (const nkMemory::StringView& oldName, const nkMemory::StringView& newName) ;
			void erase (const nkMemory::StringView& name) ;
	} ;
}