﻿//////////////////////////////////////////////
// WheelEventData.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkMaths
#include <NilkinsMaths/Geometry/Point.h>

/// Class ------------------------------------

namespace nkWinUi
{
	struct WheelEventData final
	{
		// Relative position in component
		nkMaths::Point _mouseRel ;

		// Delta wheel
		float _delta = 0.f ;

		// Whether some other button / key was down during the operation
		bool _ctrlDown = false ;
		bool _leftButtonDown = false ;
		bool _middleButtonDown = false ;
		bool _rightButtonDown = false ;
		bool _shiftKeyDown = false ;
		bool _xButton1Down = false ;
		bool _xButton2Down = false ;
	} ;
}