﻿//////////////////////////////////////////////
// LogManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkLog
{
	class Logger ;
	class MainSystem ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

// nkCommon
#include <nilkinsCommon/Patterns/MaybeSingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

/// Class ------------------------------------
	
namespace nkWinUi
{
	class DLL_WINUI_EXPORT LogManager final : public nkCommon::MaybeSingletonClass<LogManager>
	{
		friend class nkCommon::MaybeSingletonClass<LogManager> ;
		friend class MainSystem ;

		private :
		
			// Attributes
			nkLog::Logger* _receiver ;

		private :

			// Functions
			// Constructor, destructor
			LogManager () ;
			~LogManager () ;
			
		public :

			// Getters
			nkLog::Logger* getReceiver () const ;
		
			// Setters
			void setReceiver (nkLog::Logger* receiver) ;

			// Log
			void log (const nkMemory::StringView& message, const nkMemory::StringView& className) ;
	} ;
}